// u_c_zzz
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_generic_calculator;
  interface

    type c_calculator<T>=
             class
               function f_multiply(p_one, p_two: T): T; Virtual; Abstract;
             end; // compute

         c_integer_calculator=
             Class(c_calculator<Integer>)
               function f_multiply(p_one, p_two: Integer): Integer; Override;
             end; // c_integer_calculator
         c_double_calculator=
             Class(c_calculator<Double>)
               function f_multiply(p_one, p_two: Double): Double; Override;
             end; // c_double_calculator
         c_string_calculator=
             Class(c_calculator<string>)
               function f_multiply(p_one, p_two: string): string; Override;
             end; // c_string_calculator

         c_computer<T; C: c_calculator<T>, Constructor>=
             Class(c_calculator<T>)
               function f_do_multiply(p_one, p_two: T): T;
             end; // c_computer<T>

  implementation
    uses SysUtils, u_display_simple;

    // -- c_integer_calculator

    function c_integer_calculator.f_multiply(p_one, p_two: Integer): Integer;
      begin
        Result:= p_one* p_two;
      end;

    // -- c_double_calculator

    function c_double_calculator.f_multiply(p_one, p_two: Double): Double;
      begin
        Result:= p_one* p_two;
      end;

    // -- c_string_calculator

    function c_string_calculator.f_multiply(p_one, p_two: string): string;
      begin
        Result:= IntToStr(StrToInt(p_one)* StrToInt(p_two));
      end;

    // -- c_computer<T, C>

    function c_computer<T, C>.f_do_multiply(p_one, p_two: T): T;
      var l_c_calculator: C;
      begin
        l_c_calculator:= C.create;
        try
          Result:= l_c_calculator.f_multiply(p_one, p_two);
        finally
          l_c_calculator.Free;
        end;
      end; // f_do_multiply

    end. // u_c_zzz


